module Justify where

import Data.Char (isSpace)

data Line = Line String Line | Empty
            deriving (Eq, Show)

numWords :: Line-> Int
numWords = undefined

len :: Line-> Int
len = undefined

app :: Line-> String-> Line
app = undefined

stringToLine :: String-> Line
stringToLine s =
  if null s then Empty
  else Line (firstWord s) (stringToLine (restWords s)) where
  firstWord :: String-> String
  firstWord s =
    if null s then s
    else let c = head s
         in  if isSpace c then ""
                        else c: firstWord (tail s) 
  restWords :: String-> String
  restWords s =
    if null s then s
    else if isSpace (head s) then dropSpaces (tail s)
                             else restWords (tail s)
  dropSpaces :: String-> String
  dropSpaces s =
     if null s then s
     else if isSpace (head s) then dropSpaces (tail s)
                              else s

lineToString :: Line-> String
lineToString = undefined

formatLine :: Int-> Line-> String
formatLine w l = undefined

justify :: Int-> String-> String
justify w s = undefined
